org.apache.lucene.analysis

## Class Token

- java.lang.Object
- - org.apache.lucene.util.AttributeImpl
  - - org.apache.lucene.analysis.tokenattributes.CharTermAttributeImpl
    - - org.apache.lucene.analysis.Token

All Implemented Interfaces:
  Appendable, CharSequence, Cloneable, CharTermAttribute, FlagsAttribute, OffsetAttribute, PayloadAttribute, PositionIncrementAttribute, PositionLengthAttribute, TermToBytesRefAttribute, TypeAttribute, Attribute

    public class Token
    extends CharTermAttributeImpl
    implements TypeAttribute, PositionIncrementAttribute, FlagsAttribute, OffsetAttribute, PayloadAttribute, PositionLengthAttribute

A Token is an occurrence of a term from the text of a field. It consists of a term's text, the start and end offset of the term in the text of the field, and a type string.

The start and end offsets permit applications to re-associate a token with its source text, e.g., to display highlighted query terms in a document browser, or to show matching text fragments in a KWIC display, etc.

The type is a string, assigned by a lexical analyzer (a.k.a. tokenizer), naming the lexical or syntactic class that the token belongs to. For example an end of sentence marker token might be implemented with type "eos". The default token type is "word".

A Token can optionally have metadata (a.k.a. payload) in the form of a variable length byte array. Use `DocsAndPositionsEnum.getPayload()` to retrieve the payloads from the index.

NOTE: As of 2.9, Token implements all `Attribute` interfaces that are part of core Lucene and can be found in the `tokenattributes` subpackage. Even though it is not necessary to use Token anymore, with the new TokenStream API it can be used as convenience class that implements all `Attribute`s, which is especially useful to easily switch from the old to the new TokenStream API.

Tokenizers and TokenFilters should try to re-use a Token instance when possible for best performance, by implementing the `TokenStream.incrementToken()` API. Failing that, to create a new Token you should first use one of the constructors that starts with null text. To load the token from a char[] use `CharTermAttributeImpl.copyBuffer(char[], int, int)`. To load from a String use `CharTermAttributeImpl.setEmpty()` followed by `CharTermAttributeImpl.append(CharSequence)` or `CharTermAttributeImpl.append(CharSequence, int, int)`. Alternatively you can get the Token's termBuffer by calling either `CharTermAttributeImpl.buffer()`, if you know that your text is shorter than the capacity of the termBuffer or `CharTermAttributeImpl.resizeBuffer(int)`, if there is any possibility that you may need to grow the buffer. Fill in the characters of your term into this buffer, with `String.getChars(int, int, char[], int)` if loading from a string, or with `System.arraycopy(Object, int, Object, int, int)`, and finally call `CharTermAttributeImpl.setLength(int)` to set the length of the term text. See LUCENE-969 for details.

Typical Token reuse patterns:

- Copying text from a string (type is reset to `TypeAttribute.DEFAULT_TYPE` if not specified):

          return reusableToken.reinit(string, startOffset, endOffset[, type]);

- Copying some text from a string (type is reset to `TypeAttribute.DEFAULT_TYPE` if not specified):

          return reusableToken.reinit(string, 0, string.length(), startOffset, endOffset[, type]);

Copying text from char[] buffer (type is reset to `TypeAttribute.DEFAULT_TYPE` if not specified):

        return reusableToken.reinit(buffer, 0, buffer.length, startOffset, endOffset[, type]);

Copying some text from a char[] buffer (type is reset to `TypeAttribute.DEFAULT_TYPE` if not specified):

        return reusableToken.reinit(buffer, start, end - start, startOffset, endOffset[, type]);

Copying from one one Token to another (type is reset to `TypeAttribute.DEFAULT_TYPE` if not specified):

        return reusableToken.reinit(source.buffer(), 0, source.length(), source.startOffset(), source.endOffset()[, source.type()]);

A few things to note:

- clear() initializes all of the fields to default values. This was changed in contrast to Lucene 2.4, but should affect no one.
- Because `TokenStreams` can be chained, one cannot assume that the `Token's` current type is correct.
- The startOffset and endOffset represent the start and offset in the source text, so be careful in adjusting them.
- When caching a reusable token, clone it. When injecting a cached token into a stream that can be reset, clone it again.

Please note: With Lucene 3.1, the `toString()` method had to be changed to match the `CharSequence` interface introduced by the interface `CharTermAttribute`. This method now only prints the term text, no additional information anymore.

### Nested Class Summary

Nested Classes
`static class` `Token.TokenAttributeFactory` Expert: Creates a TokenAttributeFactory returning `Token` as instance for the basic attributes and for all other attributes calls the given delegate factory.

### Field Summary

Fields
`static AttributeSource.AttributeFactory` `TOKEN_ATTRIBUTE_FACTORY` Convenience factory that returns `Token` as implementation for the basic attributes and return the default impl (with "Impl" appended) for all other attributes.

### Fields inherited from interface org.apache.lucene.analysis.tokenattributes.TypeAttribute

`DEFAULT_TYPE`

### Constructor Summary

Constructors
Constructor and Description
`Token()` Constructs a Token will null text.
`Token(char[] startTermBuffer, int termBufferOffset, int termBufferLength, int start, int end)` Constructs a Token with the given term buffer (offset & length), start and end offsets
`Token(int start, int end)` Constructs a Token with null text and start & end offsets.
`Token(int start, int end, int flags)` Constructs a Token with null text and start & end offsets plus flags.
`Token(int start, int end, String typ)` Constructs a Token with null text and start & end offsets plus the Token type.
`Token(String text, int start, int end)` Constructs a Token with the given term text, and start & end offsets.
`Token(String text, int start, int end, int flags)` Constructs a Token with the given text, start and end offsets, & type.
`Token(String text, int start, int end, String typ)` Constructs a Token with the given text, start and end offsets, & type.

### Method Summary

Methods
`void` `clear()` Resets the term text, payload, flags, and positionIncrement, startOffset, endOffset and token type to default.
`Token` `clone()` Shallow clone.
`Token` `clone(char[] newTermBuffer, int newTermOffset, int newTermLength, int newStartOffset, int newEndOffset)` Makes a clone, but replaces the term buffer & start/end offset in the process.
`void` `copyTo(AttributeImpl target)` Copies the values from this Attribute into the passed-in target attribute.
`int` `endOffset()` Returns this Token's ending offset, one greater than the position of the last character corresponding to this token in the source text.
`boolean` `equals(Object obj)`
`int` `getFlags()` Get the bitset for any bits that have been set.
`BytesRef` `getPayload()` Returns this Token's payload.
`int` `getPositionIncrement()` Returns the position increment of this Token.
`int` `getPositionLength()` Returns the position length of this Token.
`int` `hashCode()`
`void` `reflectWith(AttributeReflector reflector)` This method is for introspection of attributes, it should simply add the key/values this attribute holds to the given `AttributeReflector`.
`Token` `reinit(char[] newTermBuffer, int newTermOffset, int newTermLength, int newStartOffset, int newEndOffset)` Shorthand for calling `clear()`, `CharTermAttributeImpl.copyBuffer(char[], int, int)`, `setOffset(int, int)`, `setType(java.lang.String)` on Token.DEFAULT_TYPE
`Token` `reinit(char[] newTermBuffer, int newTermOffset, int newTermLength, int newStartOffset, int newEndOffset, String newType)` Shorthand for calling `clear()`, `CharTermAttributeImpl.copyBuffer(char[], int, int)`, `setOffset(int, int)`, `setType(java.lang.String)`
`Token` `reinit(String newTerm, int newStartOffset, int newEndOffset)` Shorthand for calling `clear()`, `CharTermAttributeImpl.append(CharSequence)`, `setOffset(int, int)`, `setType(java.lang.String)` on Token.DEFAULT_TYPE
`Token` `reinit(String newTerm, int newTermOffset, int newTermLength, int newStartOffset, int newEndOffset)` Shorthand for calling `clear()`, `CharTermAttributeImpl.append(CharSequence, int, int)`, `setOffset(int, int)`, `setType(java.lang.String)` on Token.DEFAULT_TYPE
`Token` `reinit(String newTerm, int newTermOffset, int newTermLength, int newStartOffset, int newEndOffset, String newType)` Shorthand for calling `clear()`, `CharTermAttributeImpl.append(CharSequence, int, int)`, `setOffset(int, int)`, `setType(java.lang.String)`
`Token` `reinit(String newTerm, int newStartOffset, int newEndOffset, String newType)` Shorthand for calling `clear()`, `CharTermAttributeImpl.append(CharSequence)`, `setOffset(int, int)`, `setType(java.lang.String)`
`void` `reinit(Token prototype)` Copy the prototype token's fields into this one.
`void` `reinit(Token prototype, char[] newTermBuffer, int offset, int length)` Copy the prototype token's fields into this one, with a different term.
`void` `reinit(Token prototype, String newTerm)` Copy the prototype token's fields into this one, with a different term.
`void` `setFlags(int flags)` Set the flags to a new bitset.
`void` `setOffset(int startOffset, int endOffset)` Set the starting and ending offset.
`void` `setPayload(BytesRef payload)` Sets this Token's payload.
`void` `setPositionIncrement(int positionIncrement)` Set the position increment.
`void` `setPositionLength(int positionLength)` Set the position length of this Token.
`void` `setType(String type)` Set the lexical type.
`int` `startOffset()` Returns this Token's starting offset, the position of the first character corresponding to this token in the source text.
`String` `type()` Returns this Token's lexical type.

### Methods inherited from class org.apache.lucene.analysis.tokenattributes.CharTermAttributeImpl

`append, append, append, append, append, append, buffer, charAt, copyBuffer, fillBytesRef, getBytesRef, length, resizeBuffer, setEmpty, setLength, subSequence, toString`

### Methods inherited from class org.apache.lucene.util.AttributeImpl

`reflectAsString`

### Methods inherited from class java.lang.Object

`finalize, getClass, notify, notifyAll, wait, wait, wait`

### Field Detail

#### TOKEN_ATTRIBUTE_FACTORY

    public static final AttributeSource.AttributeFactory TOKEN_ATTRIBUTE_FACTORY

Convenience factory that returns `Token` as implementation for the basic attributes and return the default impl (with "Impl" appended) for all other attributes.

Since:
  3.0

### Constructor Detail

#### Token

    public Token()

Constructs a Token will null text.

#### Token

    public Token(int start,
         int end)

Constructs a Token with null text and start & end offsets.

Parameters:
  `start` - start offset in the source text
  `end` - end offset in the source text

#### Token

    public Token(int start,
         int end,
         String typ)

Constructs a Token with null text and start & end offsets plus the Token type.

Parameters:
  `start` - start offset in the source text
  `end` - end offset in the source text
  `typ` - the lexical type of this Token

#### Token

    public Token(int start,
         int end,
         int flags)

Constructs a Token with null text and start & end offsets plus flags. NOTE: flags is EXPERIMENTAL.

Parameters:
  `start` - start offset in the source text
  `end` - end offset in the source text
  `flags` - The bits to set for this token

#### Token

    public Token(String text,
         int start,
         int end)

Constructs a Token with the given term text, and start & end offsets. The type defaults to "word." NOTE: for better indexing speed you should instead use the char[] termBuffer methods to set the term text.

Parameters:
  `text` - term text
  `start` - start offset in the source text
  `end` - end offset in the source text

#### Token

    public Token(String text,
         int start,
         int end,
         String typ)

Constructs a Token with the given text, start and end offsets, & type. NOTE: for better indexing speed you should instead use the char[] termBuffer methods to set the term text.

Parameters:
  `text` - term text
  `start` - start offset in the source text
  `end` - end offset in the source text
  `typ` - token type

#### Token

    public Token(String text,
         int start,
         int end,
         int flags)

Constructs a Token with the given text, start and end offsets, & type. NOTE: for better indexing speed you should instead use the char[] termBuffer methods to set the term text.

Parameters:
  `text` - term text
  `start` - start offset in the source text
  `end` - end offset in the source text
  `flags` - token type bits

#### Token

    public Token(char[] startTermBuffer,
         int termBufferOffset,
         int termBufferLength,
         int start,
         int end)

Constructs a Token with the given term buffer (offset & length), start and end offsets

Parameters:
  `startTermBuffer` - buffer containing term text
  `termBufferOffset` - the index in the buffer of the first character
  `termBufferLength` - number of valid characters in the buffer
  `start` - start offset in the source text
  `end` - end offset in the source text

### Method Detail

#### setPositionIncrement

    public void setPositionIncrement(int positionIncrement)

Set the position increment. The default value is one.

Specified by:
  `setPositionIncrement` in interface `PositionIncrementAttribute`
Parameters:
  `positionIncrement` - the distance from the prior term
See Also:
  `PositionIncrementAttribute`

#### getPositionIncrement

    public int getPositionIncrement()

Returns the position increment of this Token.

Specified by:
  `getPositionIncrement` in interface `PositionIncrementAttribute`
See Also:
  `PositionIncrementAttribute`

#### setPositionLength

    public void setPositionLength(int positionLength)

Set the position length of this Token.

The default value is one.

Specified by:
  `setPositionLength` in interface `PositionLengthAttribute`
Parameters:
  `positionLength` - how many positions this token spans.
See Also:
  `PositionLengthAttribute`

#### getPositionLength

    public int getPositionLength()

Returns the position length of this Token.

Specified by:
  `getPositionLength` in interface `PositionLengthAttribute`
See Also:
  `PositionLengthAttribute`

#### startOffset

    public final int startOffset()

Returns this Token's starting offset, the position of the first character corresponding to this token in the source text.

Note that the difference between `OffsetAttribute.endOffset()` and `startOffset()` may not be equal to termText.length(), as the term text may have been altered by a stemmer or some other filter.

Specified by:
  `startOffset` in interface `OffsetAttribute`
See Also:
  `OffsetAttribute`

#### endOffset

    public final int endOffset()

Returns this Token's ending offset, one greater than the position of the last character corresponding to this token in the source text. The length of the token in the source text is (`endOffset()` - `OffsetAttribute.startOffset()`).

Specified by:
  `endOffset` in interface `OffsetAttribute`
See Also:
  `OffsetAttribute`

#### setOffset

    public void setOffset(int startOffset,
                 int endOffset)

Set the starting and ending offset.

Specified by:
  `setOffset` in interface `OffsetAttribute`
See Also:
  `OffsetAttribute`

#### type

    public final String type()

Returns this Token's lexical type. Defaults to "word".

Specified by:
  `type` in interface `TypeAttribute`
See Also:
  `TypeAttribute`

#### setType

    public final void setType(String type)

Set the lexical type.

Specified by:
  `setType` in interface `TypeAttribute`
See Also:
  `TypeAttribute`

#### getFlags

    public int getFlags()

Get the bitset for any bits that have been set.

Specified by:
  `getFlags` in interface `FlagsAttribute`
Returns:
  The bits
See Also:
  `FlagsAttribute`

#### setFlags

    public void setFlags(int flags)

Set the flags to a new bitset.

Specified by:
  `setFlags` in interface `FlagsAttribute`
See Also:
  `FlagsAttribute`

#### getPayload

    public BytesRef getPayload()

Returns this Token's payload.

Specified by:
  `getPayload` in interface `PayloadAttribute`
See Also:
  `PayloadAttribute`

#### setPayload

    public void setPayload(BytesRef payload)

Sets this Token's payload.

Specified by:
  `setPayload` in interface `PayloadAttribute`
See Also:
  `PayloadAttribute`

#### clear

    public void clear()

Resets the term text, payload, flags, and positionIncrement, startOffset, endOffset and token type to default.

Overrides:
  `clear` in class `CharTermAttributeImpl`

#### clone

    public Token clone()

Description copied from class: `AttributeImpl`
Shallow clone. Subclasses must override this if they need to clone any members deeply,

Overrides:
  `clone` in class `CharTermAttributeImpl`

#### clone

    public Token clone(char[] newTermBuffer,
              int newTermOffset,
              int newTermLength,
              int newStartOffset,
              int newEndOffset)

Makes a clone, but replaces the term buffer & start/end offset in the process. This is more efficient than doing a full clone (and then calling `CharTermAttributeImpl.copyBuffer(char[], int, int)`) because it saves a wasted copy of the old termBuffer.

#### equals

    public boolean equals(Object obj)

Overrides:
  `equals` in class `CharTermAttributeImpl`

#### hashCode

    public int hashCode()

Overrides:
  `hashCode` in class `CharTermAttributeImpl`

#### reinit

    public Token reinit(char[] newTermBuffer,
               int newTermOffset,
               int newTermLength,
               int newStartOffset,
               int newEndOffset,
               String newType)

Shorthand for calling `clear()`, `CharTermAttributeImpl.copyBuffer(char[], int, int)`, `setOffset(int, int)`, `setType(java.lang.String)`

Returns:
  this Token instance

#### reinit

    public Token reinit(char[] newTermBuffer,
               int newTermOffset,
               int newTermLength,
               int newStartOffset,
               int newEndOffset)

Shorthand for calling `clear()`, `CharTermAttributeImpl.copyBuffer(char[], int, int)`, `setOffset(int, int)`, `setType(java.lang.String)` on Token.DEFAULT_TYPE

Returns:
  this Token instance

#### reinit

    public Token reinit(String newTerm,
               int newStartOffset,
               int newEndOffset,
               String newType)

Shorthand for calling `clear()`, `CharTermAttributeImpl.append(CharSequence)`, `setOffset(int, int)`, `setType(java.lang.String)`

Returns:
  this Token instance

#### reinit

    public Token reinit(String newTerm,
               int newTermOffset,
               int newTermLength,
               int newStartOffset,
               int newEndOffset,
               String newType)

Shorthand for calling `clear()`, `CharTermAttributeImpl.append(CharSequence, int, int)`, `setOffset(int, int)`, `setType(java.lang.String)`

Returns:
  this Token instance

#### reinit

    public Token reinit(String newTerm,
               int newStartOffset,
               int newEndOffset)

Shorthand for calling `clear()`, `CharTermAttributeImpl.append(CharSequence)`, `setOffset(int, int)`, `setType(java.lang.String)` on Token.DEFAULT_TYPE

Returns:
  this Token instance

#### reinit

    public Token reinit(String newTerm,
               int newTermOffset,
               int newTermLength,
               int newStartOffset,
               int newEndOffset)

Shorthand for calling `clear()`, `CharTermAttributeImpl.append(CharSequence, int, int)`, `setOffset(int, int)`, `setType(java.lang.String)` on Token.DEFAULT_TYPE

Returns:
  this Token instance

#### reinit

    public void reinit(Token prototype)

Copy the prototype token's fields into this one. Note: Payloads are shared.

Parameters:
  `prototype` - source Token to copy fields from

#### reinit

    public void reinit(Token prototype,
              String newTerm)

Copy the prototype token's fields into this one, with a different term. Note: Payloads are shared.

Parameters:
  `prototype` - existing Token
  `newTerm` - new term text

#### reinit

    public void reinit(Token prototype,
              char[] newTermBuffer,
              int offset,
              int length)

Copy the prototype token's fields into this one, with a different term. Note: Payloads are shared.

Parameters:
  `prototype` - existing Token
  `newTermBuffer` - buffer containing new term text
  `offset` - the index in the buffer of the first character
  `length` - number of valid characters in the buffer

#### copyTo

    public void copyTo(AttributeImpl target)

Description copied from class: `AttributeImpl`
Copies the values from this Attribute into the passed-in target attribute. The target implementation must support all the Attributes this implementation supports.

Overrides:
  `copyTo` in class `CharTermAttributeImpl`

#### reflectWith

    public void reflectWith(AttributeReflector reflector)

Description copied from class: `AttributeImpl`
This method is for introspection of attributes, it should simply add the key/values this attribute holds to the given `AttributeReflector`.

The default implementation calls `AttributeReflector.reflect(java.lang.Class<? extends org.apache.lucene.util.Attribute>, java.lang.String, java.lang.Object)` for all non-static fields from the implementing class, using the field name as key and the field value as value. The Attribute class is also determined by reflection. Please note that the default implementation can only handle single-Attribute implementations.

Custom implementations look like this (e.g. for a combined attribute implementation):

       public void reflectWith(AttributeReflector reflector) {
         reflector.reflect(CharTermAttribute.class, "term", term());
         reflector.reflect(PositionIncrementAttribute.class, "positionIncrement", getPositionIncrement());
       }

If you implement this method, make sure that for each invocation, the same set of `Attribute` interfaces and keys are passed to `AttributeReflector.reflect(java.lang.Class<? extends org.apache.lucene.util.Attribute>, java.lang.String, java.lang.Object)` in the same order, but possibly different values. So don't automatically exclude e.g. `null` properties!

Overrides:
  `reflectWith` in class `CharTermAttributeImpl`
See Also:
  `AttributeImpl.reflectAsString(boolean)`